var endState = {
	
	create: function() {
		
		//----------------------------------------------------------------------------
		//                              SPACE BACKGROUND
		//----------------------------------------------------------------------------
		stars = game.add.sprite(centerX, centerY - 50, "stars");
		stars.anchor.set(0.5);
		game.add.tween(stars).to({angle:360}, 17000, Phaser.Easing.Linear.None).start().repeat(-1);
		
		//---------------------------------------------------------------------
		//                              FIREWORKS
		//---------------------------------------------------------------------
		bonuses = [];
		for (var k = 0; k < 4; k++) {
			bonuses[k] = game.add.group();
			for (var i = 0; i < 12; i++) {
				var bonus = game.add.sprite(-100, 0, "bonus");
				bonus.anchor.set(0.5);
				bonus.status = "ready";
				bonus.ySpeed = 0;
				bonus.xSpeed = 0;
				bonus.reset = function() {
					this.x = -100;
					this.y = 0;
					this.ySpeed = 0;
					this.xSpeed = 0;
					this.alpha = 1;
					this.status = "ready";
				}
				bonus.start = function(x, y, frame, angle) {
					this.x = x;
					this.y = y;
					//this.ySpeed = game.rnd.integerInRange(-50, 30) / 12;
					//this.xSpeed = game.rnd.integerInRange(-30, 30) / 14;
					this.ySpeed = 2 * Math.sin(angle) + game.rnd.integerInRange(-10, 10)/20;
					this.xSpeed = 2 * Math.cos(angle) + game.rnd.integerInRange(-10, 10)/20;
					this.frame = frame;
					this.status = "falling";
					game.add.tween(this).to({alpha: 0}, 400, Phaser.Easing.Linear.None, true, 1250);
				}
				bonus.update = function() {
					if (this.status == "falling") {
						this.y += this.ySpeed;
						this.ySpeed += 0.1;
						this.x += this.xSpeed;
						if (this.alpha == 0) this.reset();
					}
				}
				bonuses[k].add(bonus);
			}
		}
		
		//---------------------------------------------------------------------
		//                              END TEXTS
		//---------------------------------------------------------------------
		endStateText1 = game.add.sprite(centerX, 158, "endStateText1");
		endStateText1.anchor.set(0.5);
		endStateText1.scale.set(0);
		endStateText2 = game.add.sprite(centerX, 900, "endStateText2");
		endStateText2.anchor.set(0.5);
		endStateText2.scale.set(0);
		
		//---------------------------------------------------------------------------
		//                              OK SOUND BUTTON
		//---------------------------------------------------------------------------
		endOKButton = tweenButton(centerX, 950, "endOKButton", function() { menuMusic.pause(); closeDoors("menuState"); }, buttonClick, 0.5);
		
		openDoors();
		
		//---------------------------------------------------------------------
		//                              WIN SOUND
		//---------------------------------------------------------------------
		game.time.events.add(Phaser.Timer.SECOND * 0.5, function() {
			if (!soundsAreMuted) { winSound.play(); };
			game.add.tween(endStateText2.scale).to({x: 1, y: 1}, 1350, Phaser.Easing.Sinusoidal.Out, true);
			game.add.tween(endStateText2).to({y: 318}, 1350, Phaser.Easing.Sinusoidal.Out, true).onComplete.add(function() {
				game.add.tween(endStateText1.scale).to({x: 1, y: 1}, 750, Phaser.Easing.Bounce.Out, true, 50).onComplete.add(function() {
					game.add.tween(endOKButton).to({y: 605}, 1750, Phaser.Easing.Sinusoidal.Out, true, 300)
				});
			});
		});
		
		//-----------------------------------------------------------------------
		//                              START MUSIC
		//-----------------------------------------------------------------------
		game.time.events.add(Phaser.Timer.SECOND * 3.0, function() {
			if (!musicIsMuted) {
				menuMusic.play();
			};
		});
		
		function goBoom1() {
			x = game.rnd.integerInRange(50, 200);
			y = game.rnd.integerInRange(50, 200);
			frame = game.rnd.integerInRange(0, 9);
			for (var i = 0; i < bonuses[0].length; i++) {
				bonuses[0].children[i].start(x, y, frame, 6.28/bonuses[0].length*i);
			}
		}
		
		function goBoom2() {
			x = game.rnd.integerInRange(300, 450);
			y = game.rnd.integerInRange(50, 200);
			frame = game.rnd.integerInRange(0, 9);
			for (var i = 0; i < bonuses[1].length; i++) {
				bonuses[1].children[i].start(x, y, frame, 6.28/bonuses[0].length*i);
			}
		}
		
		function goBoom3() {
			x = game.rnd.integerInRange(50, 200);
			y = game.rnd.integerInRange(300, 450);
			frame = game.rnd.integerInRange(0, 9);
			for (var i = 0; i < bonuses[2].length; i++) {
				bonuses[2].children[i].start(x, y, frame, 6.28/bonuses[0].length*i);
			}
		}
		
		function goBoom4() {
			x = game.rnd.integerInRange(300, 450);
			y = game.rnd.integerInRange(300, 450);
			frame = game.rnd.integerInRange(0, 9);
			for (var i = 0; i < bonuses[3].length; i++) {
				bonuses[3].children[i].start(x, y, frame, 6.28/bonuses[0].length*i);
			}
		}
		
		game.time.events.loop(Phaser.Timer.SECOND*1.81, function() {
			goBoom1();
		});
		
		game.time.events.loop(Phaser.Timer.SECOND*2.11, function() {
			goBoom2();
		});
		
		game.time.events.loop(Phaser.Timer.SECOND*2.41, function() {
			goBoom3();
		});
		
		game.time.events.loop(Phaser.Timer.SECOND*2.71, function() {
			goBoom4();
		});
		
		goBoom1();
		
		game.time.events.add(Phaser.Timer.SECOND * 0.3, function() { goBoom2(); });
		
		game.time.events.add(Phaser.Timer.SECOND * 0.6, function() { goBoom3(); });
		
		game.time.events.add(Phaser.Timer.SECOND * 0.9, function() { goBoom4(); });
		
	},
	
	
	update: function () {
		
		//
	
	}
	
}
