var menuState = {
	
	create: function() {
		
		//--------------------------------------------------------------------
		//                              SHOW FPS
		//--------------------------------------------------------------------
		if (showFPS) game.time.advancedTiming = true;
		
		//----------------------------------------------------------------------------
		//                              SPACE BACKGROUND
		//----------------------------------------------------------------------------
		stars = game.add.sprite(centerX, centerY - 50, "stars");
		stars.anchor.set(0.5);
		game.add.tween(stars).to({angle:360}, 17000, Phaser.Easing.Linear.None).start().repeat(-1);
		
		//--------------------------------------------------------------------
		//                              ADD ORBS
		//--------------------------------------------------------------------
		function addOrb(x, y, orbFrame) {
			orbSprite = game.add.sprite(x, y, "orb");
			orbSprite.anchor.set(0.5);
			orbSprite.scale.set(1.25);
			orbSprite.frame = orbFrame;
			game.add.tween(orbSprite.anchor).to({x: game.rnd.integerInRange(430, 465)/1000}, game.rnd.integerInRange(700, 1000), Phaser.Easing.Sinusoidal.InOut, true, game.rnd.integerInRange(0, 800), -1, true);
			game.add.tween(orbSprite.anchor).to({y: game.rnd.integerInRange(400, 455)/1000}, game.rnd.integerInRange(700, 1000), Phaser.Easing.Sinusoidal.InOut, true, game.rnd.integerInRange(0, 800), -1, true);
			orbSprite.angle = game.rnd.integerInRange(-20, 20);
			game.add.tween(orbSprite).to({angle:game.rnd.integerInRange(-20, 20)}, game.rnd.integerInRange(900, 1300), Phaser.Easing.Sinusoidal.InOut).yoyo(true).start().repeat(-1);
		}
		addOrb(80, 480, 1, 1); addOrb(420, 480, 9, 1);
		addOrb(80, 580, 3, 1); addOrb(420, 580, 8, 1);
		
		//------------------------------------------------------------------
		//                              PLANET
		//------------------------------------------------------------------
		planet = game.add.sprite(centerX, gameHeight+20, "planet");
		planet.anchor.setTo(0.5, 1);
		game.add.tween(planet).to({y:gameHeight+40}, 3000, Phaser.Easing.Sinusoidal.InOut).yoyo(true).start().repeat(-1);
		
		//----------------------------------------------------------------------
		//                              MENU TITLE
		//----------------------------------------------------------------------
		title = game.add.sprite(centerX, 210, "title");
		title.anchor.set(0.5);
		game.add.tween(title.scale).to({x:0.95, y:1.03}, 1750, Phaser.Easing.Sinusoidal.InOut).yoyo(true).start().repeat(-1);
		game.add.tween(title).to({y:title.y+10}, 1350, Phaser.Easing.Sinusoidal.InOut).yoyo(true).start().repeat(-1);
		
		//------------------------------------------------------------------------
		//                              START BUTTON
		//------------------------------------------------------------------------
		startButton = tweenButton(centerX, 535, "startButton", function() {
			try {
				parent.cmgGameEvent("start");
			} catch(error) {
				// cmgGameEvent not present
			}
			menuMusic.pause();
			closeDoors("levelState");
		}, buttonClick, 0.25);
		
		//-----------------------------------------------------------------------------
		//                              MUTE SOUND BUTTON
		//-----------------------------------------------------------------------------
		muteSoundButton = tweenButton(70, 740, "soundButtonOn", muteSoundButtonAction, null, -1);
		if (soundsAreMuted) { muteSoundButton.loadTexture("soundButtonOff"); };
		function muteSoundButtonAction() {
			soundsAreMuted = !soundsAreMuted;
			if (soundsAreMuted) {
				muteSoundButton.loadTexture("soundButtonOff");
			} else {
				buttonClick.play();
				muteSoundButton.loadTexture("soundButtonOn");
			}
		}
		
		//-----------------------------------------------------------------------------
		//                              MUTE MUSIC BUTTON
		//-----------------------------------------------------------------------------
		muteMusicButton = tweenButton(170, 740, "musicButtonOn", muteMusicButtonAction, buttonClick, -1);
		if (musicIsMuted) { muteMusicButton.loadTexture("musicButtonOff"); };
		function muteMusicButtonAction() {
			musicIsMuted = !musicIsMuted;
			if (musicIsMuted) {
				menuMusic.stop();
				muteMusicButton.loadTexture("musicButtonOff");
			} else {
				menuMusic.play();
				muteMusicButton.loadTexture("musicButtonOn");
			}
		}
		
		//-----------------------------------------------------------------------
		//                              INFO BUTTON
		//-----------------------------------------------------------------------
		infoButton = tweenButton(430, 740, "infoButton", function() { game.add.tween(infoDialog.scale).to({x: 1,y: 1}, 650, Phaser.Easing.Elastic.Out, true); }, buttonClick);
		
		//------------------------------------------------------------------------------
		//                              INFORMATION DIALOG
		//------------------------------------------------------------------------------
		infoDialog = game.add.sprite(centerX, centerY, "infoDialog");
		infoDialog.anchor.set(0.5);
		infoDialog.inputEnabled = true;
		
		//========== CLOSE BUTTON ==========
		closeButton = tweenButton(0, 148, "yesButton", function() { game.add.tween(infoDialog.scale).to({x: 0,y: 0}, 100, Phaser.Easing.Linear.None, true); }, buttonClick, 0.25);
		infoDialog.addChild(closeButton);
		
		infoDialog.scale.set(0);
		
		openDoors();
		
		playLevel = 0;
		
		//-----------------------------------------------------------------------
		//                              START MUSIC
		//-----------------------------------------------------------------------
		game.time.events.add(Phaser.Timer.SECOND * 0.5, function() {
			if (!musicIsMuted) {
				menuMusic.resume();
			};
		});
		
		//--------------------------------------------------------------------
		//                              SHOW FPS
		//--------------------------------------------------------------------
		if (showFPS) text = game.add.text(20, 750, "", {fill: "#CCCCCC", fontSize: 40});
		
	},
	
	
	update: function () {
		
		//-----------------------------------------------------------------------------
		//                              CHECK FOR UNLOCK
		//-----------------------------------------------------------------------------
		if (unlockStatus == "unlock") {
			makeAllLevelsAvailable();
		}
		
		//--------------------------------------------------------------------
		//                              SHOW FPS
		//--------------------------------------------------------------------
		if (showFPS) text.setText(game.time.fps);
	
	}
	
}
