var playState = {
	
	create: function() {
		
		//--------------------------------------------------------------------
		//                              SHOW FPS
		//--------------------------------------------------------------------
		if (showFPS) game.time.advancedTiming = true;
		
		//--------------------------------------------------------------------------------------
		//                              RESTART PHYSICS IF STOPPED
		//--------------------------------------------------------------------------------------
		game.physics.arcade.isPaused = false;
		
		//----------------------------------------------------------------------------
		//                              SPACE BACKGROUND
		//----------------------------------------------------------------------------
		stars = game.add.sprite(centerX, centerY - 50, "stars");
		stars.anchor.set(0.5);
		game.add.tween(stars).to({angle:360}, 17000, Phaser.Easing.Linear.None).start().repeat(-1);
		
		//------------------------------------------------------------------
		//                              PLANET
		//------------------------------------------------------------------
		planet = game.add.sprite(centerX, gameHeight+40, "planet");
		planet.anchor.setTo(0.5, 1);
		game.add.tween(planet).to({y:gameHeight+60}, 3000, Phaser.Easing.Sinusoidal.InOut).yoyo(true).start().repeat(-1);
		
		//---------------------------------------------------------------------------
		//                              BOTTOM MESSAGES
		//---------------------------------------------------------------------------
		messages = game.add.sprite(centerX, gameHeight, "messages");
		messages.anchor.setTo(0.5, 0);
		
		//------------------------------------------------------------------------
		//                              NEXT POWERUP
		//------------------------------------------------------------------------
		nextPowerup = game.add.sprite(centerX, 0, "nextPowerup");
		nextPowerup.anchor.setTo(0.5, 0.5);
		nextPowerup.animations.add("spin", [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18], 45, true);
		nextPowerup.play("spin");
		nextPowerup.status = "ready";
		nextPowerup.update = function() {
			if (this.status == "falling" && !isPaused) {
				this.y += 2.5;
				if (this.y > (ship.y - 10) && this.y < (ship.y + 10) && this.x > (ship.x - 75) && this.x < (ship.x + 75)) {
					this.visible = false;
					this.status = "done";
					if (!soundsAreMuted) { nextPowerupSound.play(); };
					game.add.tween(ship).to({y: 647}, 40, Phaser.Easing.Linear.None).chain(game.add.tween(ship).to({y: 637}, 40, Phaser.Easing.Linear.None)).start();
					levelComplete();
				}
				if (this.y > 1500) this.y = 50;
			}
		}
		
		//------------------------------------------------------------------------
		//                              GUI UNDERLAY
		//------------------------------------------------------------------------
		game.add.sprite(15, 82, "playGUItop");
		
		//----------------------------------------------------------------
		//                              BALL
		//----------------------------------------------------------------
		ballMaxSpeed = 600;
		
		ball = game.add.sprite(-200, 0, "ball");
		ball.anchor.set(0.5);
		game.physics.arcade.enable(ball);
		ball.body.setCircle(11, 4, 4);
		ball.body.bounce.set(1);
		ball.body.mass = 0.01;
		ball.body.maxVelocity.set(ballMaxSpeed, ballMaxSpeed);
		ball.body.acceleration.y = 300;
		
		aniSeq1 = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9];
		aniSeq2 = [10, 11, 12, 13, 14, 15, 16, 17, 18, 19];
		aniSeq3 = [20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39];
		aniSeq4 = aniSeq1.reverse();
		aniSeq5 = aniSeq2.reverse();
		aniSeq6 = aniSeq3.reverse();
		ball.animations.add("ani0", aniSeq4, 35, true);
		ball.animations.add("ani1", aniSeq4, 40, true);
		ball.animations.add("ani2", aniSeq4, 45, true);
		ball.animations.add("ani3", aniSeq1, 35, true);
		ball.animations.add("ani4", aniSeq1, 40, true);
		ball.animations.add("ani5", aniSeq1, 45, true);
		ball.animations.add("ani6", aniSeq2, 35, true);
		ball.animations.add("ani7", aniSeq2, 40, true);
		ball.animations.add("ani8", aniSeq2, 45, true);
		ball.animations.add("ani9", aniSeq5, 35, true);
		ball.animations.add("ani10", aniSeq5, 40, true);
		ball.animations.add("ani11", aniSeq5, 45, true);
		ball.animations.add("ani12", aniSeq6, 40, true);
		ball.animations.add("ani13", aniSeq6, 50, true);
		ball.animations.add("ani14", aniSeq6, 60, true);
		ball.animations.add("ani15", aniSeq3, 40, true);
		ball.animations.add("ani16", aniSeq3, 50, true);
		ball.animations.add("ani17", aniSeq3, 60, true);
		ball.play("ani1");
		
		ball.exists = false;
		
		//----------------------------------------------------------------
		//                              SHIP
		//----------------------------------------------------------------
		//========== EMPTY PARENT SPRITE ==========
		ship = game.add.sprite(centerX, 637, "");
		ship.anchor.set(0.5);
		game.physics.arcade.enable(ship);
		
		//========== SHIP CENTER DOME ==========
		shipDome = game.add.sprite(0, 22, game.add.renderTexture(99, 99));
		shipDome.anchor.set(0.5);
		game.physics.arcade.enable(shipDome);
		shipDome.body.setCircle(49.5);
		shipDome.body.immovable = true;
		ship.addChild(shipDome);
		
		shipDomeOverlap = game.add.sprite(0, -17.5, game.add.renderTexture(83, 22));
		shipDomeOverlap.anchor.set(0.5);
		game.physics.arcade.enable(shipDomeOverlap);
		shipDomeOverlap.body.immovable = true;
		ship.addChild(shipDomeOverlap);
		
		//========== SHIP LEFT ==========
		shipLeft = game.add.sprite(0, 2, game.add.renderTexture(65, 17));
		shipLeft.anchor.setTo(1, 0.5);
		game.physics.arcade.enable(shipLeft);
		shipLeft.body.immovable = true;
		ship.addChild(shipLeft);
		
		//========== SHIP LEFT END ==========
		shipLeftEnd = game.add.sprite(-65, 2, game.add.renderTexture(17, 17));
		shipLeftEnd.anchor.set(0.5);
		game.physics.arcade.enable(shipLeftEnd);
		shipLeftEnd.body.setCircle(8.5);
		shipLeftEnd.body.immovable = true;
		ship.addChild(shipLeftEnd);
		
		//========== SHIP RIGHT ==========
		shipRight = game.add.sprite(0, 2, game.add.renderTexture(65, 17));
		shipRight.anchor.setTo(0, 0.5);
		game.physics.arcade.enable(shipRight);
		shipRight.body.immovable = true;
		ship.addChild(shipRight);
		
		//========== SHIP LEFT END ==========
		shipRightEnd = game.add.sprite(65, 2, game.add.renderTexture(17, 17));
		shipRightEnd.anchor.set(0.5);
		game.physics.arcade.enable(shipRightEnd);
		shipRightEnd.body.setCircle(8.5);
		shipRightEnd.body.immovable = true;
		ship.addChild(shipRightEnd);
		
		//========== SHIP SPRITE ==========
		shipSprite = game.add.sprite(0, 0, "ship");
		shipSprite.anchor.set(0.5);
		shipSprite.animations.add("animate", [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13], 90, true);
		shipSprite.play("animate");
		ship.addChild(shipSprite);
		
		//----------------------------------------------------------------------
		//                              LOAD LEVEL
		//----------------------------------------------------------------------
		setLevel(playLevel);
		
		//------------------------------------------------------------------------
		//                              TRACK TWEENS
		//------------------------------------------------------------------------
		tweenArray = new Array();
		
		//-------------------------------------------------------------------
		//                              BONUSES
		//-------------------------------------------------------------------
		bonusesPaused = false;
		bonuses = game.add.group();
		for (var i = 0; i < 10; i++) {
			var bonus = game.add.sprite(-100, 0, "bonus");
			bonus.anchor.set(0.5);
			bonus.status = "ready";
			bonus.ySpeed = 0;
			bonus.xSpeed = 0;
			bonus.reset = function() {
				this.x = -100;
				this.y = 0;
				this.ySpeed = 0;
				this.xSpeed = 0;
				this.status = "ready";
			}
			bonus.start = function(x, y, frame) {
				this.x = x;
				this.y = y;
				this.ySpeed = game.rnd.integerInRange(-15, 15) / 10;
				this.xSpeed = game.rnd.integerInRange(3, 15) / 10;
				if (this.x > 250) this.xSpeed *= -1;
				if (frame < 10) this.frame = frame;
				if (frame > 9 && frame < 20) this.frame = frame - 10;
				if (frame > 19) this.frame = frame - 20;
				this.status = "falling";
			}
			bonus.update = function() {
				if (this.status == "falling" && !bonusesPaused) {
					this.y += this.ySpeed;
					this.ySpeed += 0.1;
					this.x += this.xSpeed;
					if (this.y > 850) this.reset();
					if (this.y > (ship.y - 10) && this.y < (ship.y + 10) && this.x > (ship.x - 75) && this.x < (ship.x + 75)) {
						if (!soundsAreMuted) { bonusPickup.play(); };
						progressBar.scale.x += 0.01;
						if (progressBar.scale.x > 1) progressBar.scale.x = 1;
						game.add.tween(ship).to({y: 647}, 40, Phaser.Easing.Linear.None).chain(game.add.tween(ship).to({y: 637}, 40, Phaser.Easing.Linear.None)).start();
						this.reset();
					}
				}
			}
			bonuses.add(bonus);
		}
		
		//-------------------------------------------------------------------------------
		//                              CREATE ORB FUNCTION
		//-------------------------------------------------------------------------------
		orbs = game.add.group();
		totalOrbs = 0;
		//========== TRACK JUMP GATES ==========
		jumpGateNumber = 0;
		totalJumpGates = 0;
		
		function createOrb(xPosition, yPosition, colorString) {
			if (colorString == "A" || colorString == "a") {
				orbSprite = game.add.sprite(xPosition, yPosition, "asteroid");
				orbSprite.anchor.set(0.5);
				orbSprite.animations.add("spin", [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 
																	20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 
																	40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58], 30, true);
				orbSprite.play("spin");
				game.physics.arcade.enable(orbSprite);
				orbSprite.body.setCircle(28, 2, 2);
				orbSprite.body.immovable = true;
				orbSprite.scale.setTo(1.05);
				tweenArray.push(game.add.tween(orbSprite.anchor).to({x: game.rnd.integerInRange(360, 430)/1000}, game.rnd.integerInRange(800, 1000), Phaser.Easing.Sinusoidal.InOut, true, game.rnd.integerInRange(0, 800), -1, true));
				orbSprite.angle = game.rnd.integerInRange(-30, 30);
			} else if (colorString == "F" || colorString == "f") {
				orbSprite = game.add.sprite(xPosition, yPosition, "fire");
				orbSprite.anchor.set(0.5);
				orbSprite.animations.add("burn", [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18], 20, true);
				orbSprite.play("burn");
				game.physics.arcade.enable(orbSprite);
				orbSprite.body.setCircle(28, 2, 2);
				orbSprite.body.immovable = true;
				orbSprite.scale.setTo(1.1);
				tweenArray.push(game.add.tween(orbSprite.scale).to({x: 1.0, y: 1.0}, game.rnd.integerInRange(200, 300), Phaser.Easing.Sinusoidal.InOut, true, game.rnd.integerInRange(0, 800), -1, true));
				tweenArray.push(game.add.tween(orbSprite.anchor).to({y: game.rnd.integerInRange(360, 430)/1000}, game.rnd.integerInRange(700, 1000), Phaser.Easing.Sinusoidal.InOut, true, game.rnd.integerInRange(0, 800), -1, true));
				tweenArray.push(game.add.tween(orbSprite.anchor).to({x: game.rnd.integerInRange(310, 405)/1000}, game.rnd.integerInRange(700, 1000), Phaser.Easing.Sinusoidal.InOut, true, game.rnd.integerInRange(0, 800), -1, true));
				orbSprite.angle = game.rnd.integerInRange(-50, 50);
				tweenArray.push(game.add.tween(orbSprite).to({angle:game.rnd.integerInRange(-50, 50)}, game.rnd.integerInRange(700, 1200), Phaser.Easing.Sinusoidal.InOut).yoyo(true).start().repeat(-1));
			} else if (colorString == "J" || colorString == "j") {
				orbSprite = game.add.sprite(xPosition, yPosition, "jump");
				orbSprite.anchor.set(0.5);
				orbSprite.animations.add("wave", [0, 1, 2, 3, 4, 5, 6, 7, 8, 9], 20, true);
				orbSprite.play("wave");
				game.physics.arcade.enable(orbSprite);
				orbSprite.body.setCircle(28, 2, 2);
				orbSprite.body.immovable = true;
				tweenArray.push(game.add.tween(orbSprite.anchor).to({y: game.rnd.integerInRange(360, 430)/1000}, game.rnd.integerInRange(1700, 2000), Phaser.Easing.Sinusoidal.InOut, true, game.rnd.integerInRange(0, 800), -1, true));
				tweenArray.push(game.add.tween(orbSprite.anchor).to({x: game.rnd.integerInRange(310, 405)/1000}, game.rnd.integerInRange(1700, 2000), Phaser.Easing.Sinusoidal.InOut, true, game.rnd.integerInRange(0, 800), -1, true));
				orbSprite.angle = game.rnd.integerInRange(-60, -15);
				tweenArray.push(game.add.tween(orbSprite).to({angle:game.rnd.integerInRange(15, 60)}, game.rnd.integerInRange(1700, 2600), Phaser.Easing.Sinusoidal.InOut).yoyo(true).start().repeat(-1));
				jumpGateNumber++;
				orbSprite.number = jumpGateNumber;
				totalJumpGates++;
			} else {
				orbSprite = game.add.sprite(xPosition, yPosition, "orb");
				orbSprite.anchor.set(0.5);
				game.physics.arcade.enable(orbSprite);
				orbSprite.body.setCircle(24, 12, 2);
				orbSprite.body.immovable = true;
				if (colorString == "W" || colorString == "w") orbSprite.frame = 0 + 10 * game.rnd.integerInRange(0, 2);
				if (colorString == "Y" || colorString == "y") orbSprite.frame = 1 + 10 * game.rnd.integerInRange(0, 2);
				if (colorString == "O" || colorString == "o") orbSprite.frame = 2 + 10 * game.rnd.integerInRange(0, 2);
				if (colorString == "R" || colorString == "r") orbSprite.frame = 3 + 10 * game.rnd.integerInRange(0, 2);
				if (colorString == "K" || colorString == "k") orbSprite.frame = 4 + 10 * game.rnd.integerInRange(0, 2);
				if (colorString == "V" || colorString == "v") orbSprite.frame = 5 + 10 * game.rnd.integerInRange(0, 2);
				if (colorString == "P" || colorString == "p") orbSprite.frame = 6 + 10 * game.rnd.integerInRange(0, 2);
				if (colorString == "C" || colorString == "c") orbSprite.frame = 7 + 10 * game.rnd.integerInRange(0, 2);
				if (colorString == "G" || colorString == "g") orbSprite.frame = 8 + 10 * game.rnd.integerInRange(0, 2);
				if (colorString == "B" || colorString == "b") orbSprite.frame = 9 + 10 * game.rnd.integerInRange(0, 2);
				tweenArray.push(game.add.tween(orbSprite.anchor).to({x: game.rnd.integerInRange(360, 430)/1000}, game.rnd.integerInRange(700, 1000), Phaser.Easing.Sinusoidal.InOut, true, game.rnd.integerInRange(0, 800), -1, true));
				tweenArray.push(game.add.tween(orbSprite.anchor).to({y: game.rnd.integerInRange(310, 405)/1000}, game.rnd.integerInRange(700, 1000), Phaser.Easing.Sinusoidal.InOut, true, game.rnd.integerInRange(0, 800), -1, true));
				orbSprite.angle = game.rnd.integerInRange(-20, 20);
				tweenArray.push(game.add.tween(orbSprite).to({angle:game.rnd.integerInRange(-20, 20)}, game.rnd.integerInRange(700, 1200), Phaser.Easing.Sinusoidal.InOut).yoyo(true).start().repeat(-1));
				totalOrbs += 1;
			}
			
			orbs.add(orbSprite);
			return orbSprite;
		}
		
		//----------------------------------------------------------------------------------------
		//                              ADD LINE AND STATIONARY ORBS
		//----------------------------------------------------------------------------------------
		linesPaused = false;
		for (var i = 0; i < orbMap.length; i++) {
			
			//========== LINE ORBS ==========
			if (orbMap[i][0] == "L") {
				
				if (orbMap[i][2] == "0") { lineSpacing = 75 + 0 * 10; lineSpeed = 1.0; }
				if (orbMap[i][2] == "1") { lineSpacing = 75 + 0 * 10; lineSpeed = 1.25; }
				if (orbMap[i][2] == "2") { lineSpacing = 75 + 0 * 10; lineSpeed = 1.5; }
				if (orbMap[i][2] == "3") { lineSpacing = 75 + 1.46 * 10; lineSpeed = 1.0; }
				if (orbMap[i][2] == "4") { lineSpacing = 75 + 1.46 * 10; lineSpeed = 1.25; }
				if (orbMap[i][2] == "5") { lineSpacing = 75 + 1.46 * 10; lineSpeed = 1.5; }
				if (orbMap[i][2] == "6") { lineSpacing = 75 + 5.7 * 10; lineSpeed = 1.0; }
				if (orbMap[i][2] == "7") { lineSpacing = 75 + 5.7 * 10; lineSpeed = 1.25; }
				if (orbMap[i][2] == "8") { lineSpacing = 75 + 5.7 * 10; lineSpeed = 1.5; }
				if (orbMap[i][2] == "9") { lineSpacing = 75 + 10.42 * 10; lineSpeed = 1.0; }
				
				if (orbMap[i][1] == "l") lineSpeed = -lineSpeed;
				
				lineColors = [];
				for (var k = 3; k < orbMap[i].length; k++) {
					C = orbMap[i][k];
					if (C=="J" || C=="j" || C=="F" || C=="f" || C=="A" || C=="Y" || C=="W" || C=="V" || C=="R" || C=="P" || C=="K" || C=="O" || C=="G" || C=="C" || C=="B") lineColors.push(C);
				}
				lineColors = lineColors.concat(lineColors);
				lineColors = lineColors.concat(lineColors);
				lineColors = lineColors.concat(lineColors);
				
				for (k = 0; k < Math.ceil(500 / lineSpacing); k++) {
					var orb = createOrb(k * lineSpacing + 59 - 14, i * 65 + 129, lineColors[k])
					orb.ending = Math.ceil(500 / lineSpacing) * lineSpacing - 14;
					orb.lineSpeed = lineSpeed;
					
					orb.update = function() {
						if (!linesPaused) this.x += this.lineSpeed;
						if (this.x > this.ending) this.x = -14;
						if (this.x < -14) this.x = this.ending;
					}
				}
				
			} else {
				//========== STATIONARY ORBS ==========
				for (var j = 0; j < orbMap[i].length; j += 3) {
					C = orbMap[i][j];
					if (C=="J" || C=="F" || C=="A" || C=="Y" || C=="W" || C=="V" || C=="R" || C=="P" || C=="K" || C=="O" || C=="G" || C=="C" || C=="B") {
						var orb = createOrb((j / 3) * 75 + 59, i * 65 + 129, orbMap[i][j]);
						//========== MOVE ORBS ==========
						if (orbMap[i][j + 1] == "l") tweenArray.push(game.add.tween(orb).to({x:orb.x - orbMap[i][j + 2] * 75}, 1500 + orbMap[i][j + 2] * 400, Phaser.Easing.Cubic.InOut).yoyo(true).start().repeat(-1));
						if (orbMap[i][j + 1] == "r") tweenArray.push(game.add.tween(orb).to({x:orb.x + orbMap[i][j + 2] * 75}, 1500 + orbMap[i][j + 2] * 400, Phaser.Easing.Cubic.InOut).yoyo(true).start().repeat(-1));
						if (orbMap[i][j + 1] == "u") tweenArray.push(game.add.tween(orb).to({y:orb.y - orbMap[i][j + 2] * 60}, 1500 + orbMap[i][j + 2] * 400, Phaser.Easing.Cubic.InOut).yoyo(true).start().repeat(-1));
						if (orbMap[i][j + 1] == "d") tweenArray.push(game.add.tween(orb).to({y:orb.y + orbMap[i][j + 2] * 60}, 1500 + orbMap[i][j + 2] * 400, Phaser.Easing.Cubic.InOut).yoyo(true).start().repeat(-1));
						if (orbMap[i][j + 1] == "L") tweenArray.push(game.add.tween(orb).to({x:orb.x - orbMap[i][j + 2] * 75}, 2000, Phaser.Easing.Cubic.InOut).yoyo(true).start().repeat(-1));
						if (orbMap[i][j + 1] == "R") tweenArray.push(game.add.tween(orb).to({x:orb.x + orbMap[i][j + 2] * 75}, 2000, Phaser.Easing.Cubic.InOut).yoyo(true).start().repeat(-1));
						if (orbMap[i][j + 1] == "U") tweenArray.push(game.add.tween(orb).to({y:orb.y - orbMap[i][j + 2] * 60}, 2000, Phaser.Easing.Cubic.InOut).yoyo(true).start().repeat(-1));
						if (orbMap[i][j + 1] == "D") tweenArray.push(game.add.tween(orb).to({y:orb.y + orbMap[i][j + 2] * 60}, 2000, Phaser.Easing.Cubic.InOut).yoyo(true).start().repeat(-1));
					}
					//========== SHIFT HALF RIGHT ==========
					if (C=="j" || C=="f" || C=="a" || C=="y" || C=="w" || C=="v" || C=="r" || C=="p" || C=="k" || C=="o" || C=="g" || C=="c" || C=="b") {
						var orb = createOrb((j / 3) * 75 + 59 + (75/2), i * 65 + 129, orbMap[i][j]);
						//========== MOVE ORBS ==========
						if (orbMap[i][j + 1] == "l") tweenArray.push(game.add.tween(orb).to({x:orb.x - orbMap[i][j + 2] * 75}, 1500 + orbMap[i][j + 2] * 400, Phaser.Easing.Cubic.InOut).yoyo(true).start().repeat(-1));
						if (orbMap[i][j + 1] == "r") tweenArray.push(game.add.tween(orb).to({x:orb.x + orbMap[i][j + 2] * 75}, 1500 + orbMap[i][j + 2] * 400, Phaser.Easing.Cubic.InOut).yoyo(true).start().repeat(-1));
						if (orbMap[i][j + 1] == "u") tweenArray.push(game.add.tween(orb).to({y:orb.y - orbMap[i][j + 2] * 60}, 1500 + orbMap[i][j + 2] * 400, Phaser.Easing.Cubic.InOut).yoyo(true).start().repeat(-1));
						if (orbMap[i][j + 1] == "d") tweenArray.push(game.add.tween(orb).to({y:orb.y + orbMap[i][j + 2] * 60}, 1500 + orbMap[i][j + 2] * 400, Phaser.Easing.Cubic.InOut).yoyo(true).start().repeat(-1));
						if (orbMap[i][j + 1] == "L") tweenArray.push(game.add.tween(orb).to({x:orb.x - orbMap[i][j + 2] * 75}, 2000, Phaser.Easing.Cubic.InOut).yoyo(true).start().repeat(-1));
						if (orbMap[i][j + 1] == "R") tweenArray.push(game.add.tween(orb).to({x:orb.x + orbMap[i][j + 2] * 75}, 2000, Phaser.Easing.Cubic.InOut).yoyo(true).start().repeat(-1));
						if (orbMap[i][j + 1] == "U") tweenArray.push(game.add.tween(orb).to({y:orb.y - orbMap[i][j + 2] * 60}, 2000, Phaser.Easing.Cubic.InOut).yoyo(true).start().repeat(-1));
						if (orbMap[i][j + 1] == "D") tweenArray.push(game.add.tween(orb).to({y:orb.y + orbMap[i][j + 2] * 60}, 2000, Phaser.Easing.Cubic.InOut).yoyo(true).start().repeat(-1));
					}
				}
			}
		}
		
		//-----------------------------------------------------------------------------
		//                              ADD ROTATING ORBS
		//-----------------------------------------------------------------------------
		
		rotateParent = [];
		for (var k = 0; k < 10; k++) {
			rotateParent[k] = game.add.sprite(0, 0, "");
			rotateParent[k].anchor.set(0.5);
		}
		
		for (var i = 0; i < orbMap.length; i++) {
			for (var j = 0; j < orbMap[i].length; j += 3) {
				C = orbMap[i][j];
				if (C == "0" || C == "1" || C == "2" || C == "3" || C == "4" || C == "5" || C == "6" || C == "7" || C == "8" || C == "9") {
					
					D = orbMap[i][j + 1];
					if (D=="J" || D=="F" || D=="A" || D=="Y" || D=="W" || D=="V" || D=="R" || D=="P" || D=="K" || D=="O" || D=="G" || D=="C" || D=="B") {
						var orb = createOrb((j / 3) * 75 + 59, i * 65 + 129, D);
					}
					if (D=="j" || D=="f" || D=="a" || D=="y" || D=="w" || D=="v" || D=="r" || D=="p" || D=="k" || D=="o" || D=="g" || D=="c" || D=="b") {
						var orb = createOrb((j / 3) * 75 + 59 + (75/2), i * 65 + 129, D);
					}
					
					orb.chase = game.add.sprite(orb.x, orb.y, "");
					orb.chase.anchor.set(0.5);
					orb.chase.rotateType = orbMap[i][j + 2];
					orb.update = function() {
						this.x = this.chase.world.x;
						this.y = this.chase.world.y;
					}
					rotateParent[parseInt(orbMap[i][j], 10)].addChild(orb.chase);
				}
			}
		}
		
		//========== FIND CENTERS AND ROTATE ==========
		for (var i = 0; i < 10; i++) {
			allX = [];
			allY = [];
			if (rotateParent[i].children.length == 0) {
				rotateParent[i].kill();
			} else {
				for (var j = 0; j < rotateParent[i].children.length; j++) {
					allX.push(rotateParent[i].children[j].x);
					allY.push(rotateParent[i].children[j].y);
				}
				smallestX = allX[0];
				largestX = allX[0];
				smallestY = allY[0];
				largestY = allY[0];
				for (var j = 1; j < allX.length; j++) {
					if (allX[j] < smallestX) smallestX = allX[j];
					if (allX[j] > largestX) largestX = allX[j];
					if (allY[j] < smallestY) smallestY = allY[j];
					if (allY[j] > largestY) largestY = allY[j];
				}
				middleX = (smallestX + largestX) / 2;
				middleY = (smallestY + largestY) / 2;
				rotateParent[i].x = middleX;
				rotateParent[i].y = middleY;
				for (j = 0; j < rotateParent[i].children.length; j++) {
					rotateParent[i].children[j].x -= middleX;
					rotateParent[i].children[j].y -= middleY;
				}
				
				switch(rotateParent[i].children[0].rotateType) {
					case "0": tweenArray.push(game.add.tween(rotateParent[i]).to({angle: 360}, 5000, Phaser.Easing.Linear.None, true, 0, -1)); break;
					case "1": tweenArray.push(game.add.tween(rotateParent[i]).to({angle: 360}, 7500, Phaser.Easing.Linear.None, true, 0, -1)); break;
					case "2": tweenArray.push(game.add.tween(rotateParent[i]).to({angle: 360}, 10000, Phaser.Easing.Linear.None, true, 0, -1)); break;
					case "3": tweenArray.push(game.add.tween(rotateParent[i]).to({angle: 360}, 5000, Phaser.Easing.Sinusoidal.InOut, true, 0, -1)); break;
					case "4": tweenArray.push(game.add.tween(rotateParent[i]).to({angle: 360}, 7500, Phaser.Easing.Sinusoidal.InOut, true, 0, -1)); break;
					case "5": tweenArray.push(game.add.tween(rotateParent[i]).to({angle: -360}, 5000, Phaser.Easing.Linear.None, true, 0, -1)); break;
					case "6": tweenArray.push(game.add.tween(rotateParent[i]).to({angle: -360}, 7500, Phaser.Easing.Linear.None, true, 0, -1)); break;
					case "7": tweenArray.push(game.add.tween(rotateParent[i]).to({angle: -360}, 10000, Phaser.Easing.Linear.None, true, 0, -1)); break;
					case "8": tweenArray.push(game.add.tween(rotateParent[i]).to({angle: -360}, 5000, Phaser.Easing.Sinusoidal.InOut, true, 0, -1)); break;
					case "9": tweenArray.push(game.add.tween(rotateParent[i]).to({angle: -360}, 7500, Phaser.Easing.Sinusoidal.InOut, true, 0, -1)); break;
					case "a": tweenArray.push(game.add.tween(rotateParent[i]).to({angle: 360}, 5000, Phaser.Easing.Sinusoidal.InOut, true, 0, -1, true)); break;
					case "b": tweenArray.push(game.add.tween(rotateParent[i]).to({angle: 360}, 7500, Phaser.Easing.Sinusoidal.InOut, true, 0, -1, true)); break;
					case "c": tweenArray.push(game.add.tween(rotateParent[i]).to({angle: 360}, 5000, Phaser.Easing.Linear.None, true, 0, -1));
						tweenArray.push(game.add.tween(rotateParent[i].scale).to({x: 2, y: 2}, 1250, Phaser.Easing.Sinusoidal.InOut, true, 0, -1, true));
					break;
					case "d": tweenArray.push(game.add.tween(rotateParent[i]).to({angle: 360}, 7500, Phaser.Easing.Linear.None, true, 0, -1));
						tweenArray.push(game.add.tween(rotateParent[i].scale).to({x: 1.5, y: 1.5}, 1875, Phaser.Easing.Sinusoidal.InOut, true, 0, -1, true));
					break;
					case "e": tweenArray.push(game.add.tween(rotateParent[i]).to({angle: -360}, 5000, Phaser.Easing.Linear.None, true, 0, -1));
						tweenArray.push(game.add.tween(rotateParent[i].scale).to({x: 2, y: 2}, 1250, Phaser.Easing.Sinusoidal.InOut, true, 0, -1, true));
					break;
					case "f": tweenArray.push(game.add.tween(rotateParent[i]).to({angle: -360}, 7500, Phaser.Easing.Linear.None, true, 0, -1));
						tweenArray.push(game.add.tween(rotateParent[i].scale).to({x: 1.5, y: 1.5}, 1875, Phaser.Easing.Sinusoidal.InOut, true, 0, -1, true));
					break;
				}
				
			}
		}
		
		//------------------------------------------------------------------------
		//                              GUI UNDERLAY
		//------------------------------------------------------------------------
		game.add.sprite(0, 0, "underlay");
		
		//------------------------------------------------------------------------
		//                              PROGRESS BAR
		//------------------------------------------------------------------------
		progressBar = game.add.sprite(132, 18, "progressBar");
		progressBar.scale.x = 0;
		
		//-------------------------------------------------------------------------
		//                              LEVEL NUMBERS
		//-------------------------------------------------------------------------
		
		if (playLevel > 99) {
			levelNumber = numberBlock(74, 38, "levelNumbersGUI", 2, -7, playLevel);
			oneDigit = game.add.sprite(39, 38, "levelNumbersGUI");
			oneDigit.anchor.set(0.5);
			oneDigit.frame = 1;
		} else {
			if (playLevel < 10) {
				levelNumber = numberBlock(66, 38, "levelNumbersGUI", 1, 0, playLevel);
			} else {
				levelNumber = numberBlock(66, 38, "levelNumbersGUI", 2, -7, playLevel);
			}
		}
		
		//-----------------------------------------------------------------------
		//                              GUI OVERLAY
		//-----------------------------------------------------------------------
		game.add.sprite(0, 0, "playGUI");
		
		//------------------------------------------------------------------------
		//                              PAUSE BUTTON
		//------------------------------------------------------------------------
		pauseButton = game.add.button(422, 8, "pauseButton", pauseButtonAction, this, 1, 0, 2, 0);
		pauseButton.events.onInputDown.add(function() { if (!soundsAreMuted) { buttonClick.play(); } });
		function pauseButtonAction() {
			if (ball.visible) showMessage("paused");
			isPaused = true;
			timeActive = false;
			ballActive = false;
			linesPaused = true;
			bonusesPaused = true;
			game.physics.arcade.isPaused = true;
			pauseButton.input.enabled = false;
			game.add.tween(pauseDialog.scale).to({x: 1,y: 1}, 500, Phaser.Easing.Elastic.Out, true);
			for (var i = 0; i < tweenArray.length; i++) {
				tweenArray[i].pause();
			}
			ball.animations.paused = true;
		}
		
		//------------------------------------------------------------------------
		//                              PAUSE DIALOG
		//------------------------------------------------------------------------
		pauseDialog = game.add.sprite(centerX, centerY, "pauseDialog");
		pauseDialog.anchor.set(0.5);
		
		//========== MENU BUTTON ==========
		pauseDialogMenuButton = tweenButton(-110, -39, "menuButton", gotoMenu, buttonClick);
		pauseDialog.addChild(pauseDialogMenuButton);
		
		//========== REPLAY BUTTON ==========
		pauseDialogReplayButton = tweenButton(0, -39, "pauseDialogReplayButton", replayLevel, buttonClick);
		pauseDialog.addChild(pauseDialogReplayButton);
		
		//========== CONTINUE BUTTON ==========
		pauseDialogContinueButton = tweenButton(110, -39, "rightArrowButton", function() {
			hideMessage();
			isPaused = false;
			timeActive = true;
			ballActive = true;
			linesPaused = false;
			bonusesPaused = false;
			game.physics.arcade.isPaused = false;
			pauseButton.input.enabled = true;
			game.add.tween(pauseDialog.scale).to({x: 0,y: 0}, 100, Phaser.Easing.Linear.None, true);
			for (var i = 0; i < tweenArray.length; i++) {
				tweenArray[i].resume();
			}
			ball.animations.paused = false;
		}, buttonClick, 0.25);
		pauseDialog.addChild(pauseDialogContinueButton);
		
		//========== MUTE SOUND BUTTON ==========
		muteSoundButton = tweenButton(-54, 54, "soundButtonOn", muteSoundButtonAction, null, -1);
		if (soundsAreMuted) { muteSoundButton.loadTexture("soundButtonOff"); };
		function muteSoundButtonAction() {
			soundsAreMuted = !soundsAreMuted;
			if (soundsAreMuted) {
				muteSoundButton.loadTexture("soundButtonOff");
			} else {
				buttonClick.play();
				muteSoundButton.loadTexture("soundButtonOn");
			}
		}
		pauseDialog.addChild(muteSoundButton);
		
		//========== MUTE MUSIC BUTTON ==========
		muteMusicButton = tweenButton(54, 54, "musicButtonOn", muteMusicButtonAction, buttonClick, -1);
		if (musicIsMuted) { muteMusicButton.loadTexture("musicButtonOff"); };
		function muteMusicButtonAction() {
			musicIsMuted = !musicIsMuted;
			if (musicIsMuted) {
				playMusic.stop();
				muteMusicButton.loadTexture("musicButtonOff");
			} else {
				playMusic.play();
				muteMusicButton.loadTexture("musicButtonOn");
			}
		}
		pauseDialog.addChild(muteMusicButton);
		
		pauseDialog.scale.set(0);
		
		//----------------------------------------------------------------------
		//                              WIN DIALOG
		//----------------------------------------------------------------------
		winDialog = game.add.sprite(centerX, centerY, "winDialog");
		winDialog.anchor.set(0.5);
		
		winDialogActive = false;
		
		//========== LEVEL STARS ==========
		winDialogStar1 = game.add.sprite(-104, -109, "winStar");
		winDialogStar1.anchor.set(0.5);
		winDialogStar1.scale.set(3);
		winDialogStar1.alpha = 0;
		winDialogStar1.angle = 72;
		winDialog.addChild(winDialogStar1);
		
		winDialogStar2 = game.add.sprite(0, -109, "winStar");
		winDialogStar2.anchor.set(0.5);
		winDialogStar2.scale.set(3);
		winDialogStar2.alpha = 0;
		winDialogStar2.angle = 72;
		winDialog.addChild(winDialogStar2);
		
		winDialogStar3 = game.add.sprite(104, -109, "winStar");
		winDialogStar3.anchor.set(0.5);
		winDialogStar3.scale.set(3);
		winDialogStar3.alpha = 0;
		winDialogStar3.angle = 72;
		winDialog.addChild(winDialogStar3);
		
		//========== LEVEL BUTTON ==========
		winDialogMenuButton = tweenButton(-110, 30, "pauseDialogLevelButton", function() {
			game.physics.arcade.isPaused = true;
			winDialogActive = false;
			gotoLevel();
		}, buttonClick);
		winDialog.addChild(winDialogMenuButton);
		
		//========== REPLAY BUTTON ==========
		winDialogReplayButton = tweenButton(0, 30, "pauseDialogReplayButton", function() {
			game.physics.arcade.isPaused = true;
			winDialogActive = false;
			replayLevel();
		}, buttonClick);
		winDialog.addChild(winDialogReplayButton);
		
		//========== NEXT BUTTON ==========
		winDialogNextButton = tweenButton(110, 30, "nextButton", function() {
			game.physics.arcade.isPaused = true;
			winDialogActive = false;
			nextLevel();
		}, buttonClick);
		winDialog.addChild(winDialogNextButton);
		
		//========== MUTE SOUND BUTTON ==========
		winDialogMuteSoundButton = tweenButton(-54, 123, "soundButtonOn", winDialogMuteSoundButtonAction, null, -1);
		if (soundsAreMuted) { winDialogMuteSoundButton.loadTexture("soundButtonOff"); };
		function winDialogMuteSoundButtonAction() {
			soundsAreMuted = !soundsAreMuted;
			if (soundsAreMuted) {
				winDialogMuteSoundButton.loadTexture("soundButtonOff");
			} else {
				buttonClick.play();
				winDialogMuteSoundButton.loadTexture("soundButtonOn");
			}
		}
		winDialog.addChild(winDialogMuteSoundButton);
		
		//========== MUTE MUSIC BUTTON ==========
		winDialogMuteMusicButton = tweenButton(54, 123, "musicButtonOn", winDialogMuteMusicButtonAction, buttonClick, -1);
		if (musicIsMuted) { winDialogMuteMusicButton.loadTexture("musicButtonOff"); };
		function winDialogMuteMusicButtonAction() {
			musicIsMuted = !musicIsMuted;
			if (musicIsMuted) {
				menuMusic.stop();
				winDialogMuteMusicButton.loadTexture("musicButtonOff");
			} else {
				menuMusic.play();
				winDialogMuteMusicButton.loadTexture("musicButtonOn");
			}
		}
		winDialog.addChild(winDialogMuteMusicButton);
		
		winDialog.scale.set(0);
		
		//----------------------------------------------------------------------
		//                              SETUP LEVEL
		//----------------------------------------------------------------------
		//========== SELECT LEVEL MUSIC ==========
		switch(playLevel - parseInt(playLevel/4, 10) * 4) {
			case 0: playMusic = playMusic1; break;
			case 1: playMusic = playMusic2; break;
			case 2: playMusic = playMusic3; break;
			case 3: playMusic = playMusic4; break;
		}
		
		//========== CREATE PLAY VARIABLES ==========
		isPaused = false;
		isNewBall = false;
		ballActive = true;
		pauseButton.input.enabled = true;
		timeActive = true;
		newBallTimer = 0;
		newBallWait = false;
		nextPowerupTimer = 0;
		nextPowerupWait = false;
		
		//========== HIDDEN BALL TO START OFF GAME ==========
		ball.exists = true;
		ball.visible = false;
		ball.x = centerX;
		ball.y = 750;
		ball.body.velocity.x = 0;
		ball.body.velocity.y = 90;
		ball.body.acceleration.x = 0;
		ball.body.acceleration.y = 0;
		ball.play("ani1");
		
		orbsLeft = totalOrbs;
		
		//========== PROGRESS BAR TIMER ==========
		game.time.events.loop(Phaser.Timer.SECOND, function() {
			if (timeActive) {
				progressBar.scale.x -= (0.01 + playLevel/10000);
				if (progressBar.scale.x < 0) progressBar.scale.x = 0;
			}
		});
		
		//-----------------------------------------------------------------------
		//                              START LEVEL
		//-----------------------------------------------------------------------
		openDoors();
		
		//========== SHOW OPENING MESSAGES ==========
		game.time.events.add(Phaser.Timer.SECOND * 0.5, function() {
			showMessage("new level");
			game.time.events.add(Phaser.Timer.SECOND * 2.0, function() {
				hideMessage();
			});
			//========== START MUSIC ==========
			game.time.events.add(Phaser.Timer.SECOND * 1.25, function() {
				if (!musicIsMuted) {
					if (!playMusic.isPlaying) { playMusic.play(); };
				};
			});
		});
		
		//--------------------------------------------------------------------
		//                              SHOW FPS
		//--------------------------------------------------------------------
		if (showFPS) text = game.add.text(20, 750, "", {fill: "#CCCCCC", fontSize: 40});
		
	},
	
	
	//===================================================================================
	//                      _   _  ____   ____     _   _____  _____                    
	//                     | | | ||  _ \ |  _ \   / \ |_   _|| ____|                   
	//                     | | | || |_) || | | | / _ \  | |  |  _|                     
	//                     | |_| ||  __/ | |_| |/ ___ \ | |  | |___                    
	//                      \___/ |_|    |____//_/   \_\|_|  |_____|                   
	//
	//===================================================================================
	
	update: function() {
		
		//-----------------------------------------------------------------------------
		//                              CHECK FOR UNLOCK
		//-----------------------------------------------------------------------------
		if (unlockStatus == "unlock") {
			makeAllLevelsAvailable();
		}
		
		//-------------------------------------------------------------------------------
		//                              BALL GRAVITY ADJUST
		//-------------------------------------------------------------------------------
		if (ballActive && ball.y < 300) ball.body.acceleration.y = 600 - ball.y;
		
		//---------------------------------------------------------------------
		//                              MOVE SHIP
		//---------------------------------------------------------------------
		ship.body.velocity.x = 0;
		if (game.input.y > 88) ship.body.velocity.x = (game.input.x - ship.x) * 20;
		if (winDialogActive && game.input.y < 595 && !game.device.desktop) ship.body.velocity.x = 0;
		
		//--------------------------------------------------------------------------------
		//                              ALIGN BALL WITH SHIP
		//--------------------------------------------------------------------------------
		if (isNewBall) {
			ball.x = ship.x;
			ball.y = ship.y - 60;
			if (ball.x < 30) ball.x = 30;
			if (ball.x > 470) ball.x = 470;
		}
		
		if (ballActive) {
			//--------------------------------------------------------------------------
			//                              WALL COLLISION
			//--------------------------------------------------------------------------
			if (ball.x < (13 + 9.5)) {
				ball.x = 13 + 9.5;
				ball.body.velocity.x = Math.abs(ball.body.velocity.x);
				if (!soundsAreMuted && !wallHit.isPlaying) { wallHit.play(); };
				ball.play("ani"+ game.rnd.integerInRange(0, 17));
			}
			if (ball.x > 500 - (13 + 9.5)) {
				ball.x = 500 - (13 + 9.5);
				ball.body.velocity.x = -Math.abs(ball.body.velocity.x);
				if (!soundsAreMuted && !wallHit.isPlaying) { wallHit.play(); };
				ball.play("ani"+ game.rnd.integerInRange(0, 17));
			}
			if (ball.y < (88 + 9.5)) {
				ball.y = 88 + 9.5;
				ball.body.velocity.y = Math.abs(ball.body.velocity.y);
				if (!soundsAreMuted && !wallHit.isPlaying) { wallHit.play(); };
				ball.play("ani"+ game.rnd.integerInRange(0, 17));
			}
			
			//--------------------------------------------------------------------------
			//                              SHIP COLLISION
			//--------------------------------------------------------------------------
			//========== SHIP DOME ==========
			game.physics.arcade.overlap(ball, shipDome, function(ball, shipDome) {
				game.physics.arcade.overlap(ball, shipDomeOverlap, function(ball, shipDomeOverlap) {
					ball.body.velocity.x = (ball.x - shipDome.world.x)*20;
					ball.body.velocity.y = (ball.y - shipDome.world.y)*20;
					ball.body.velocity.x *= ballMaxSpeed / Math.sqrt(ball.body.velocity.x * ball.body.velocity.x + ball.body.velocity.y * ball.body.velocity.y);
					ball.body.velocity.y *= ballMaxSpeed / Math.sqrt(ball.body.velocity.x * ball.body.velocity.x + ball.body.velocity.y * ball.body.velocity.y);
					ball.body.velocity.x += ship.deltaX * 10;
					ball.x += ship.deltaX;
					if (!soundsAreMuted && !shipHit.isPlaying) { shipHit.play(); };
					ball.play("ani"+ game.rnd.integerInRange(0, 17));
					ball.body.acceleration.y = 300;
					game.add.tween(ship).to({y: 647}, 40, Phaser.Easing.Linear.None).chain(game.add.tween(ship).to({y: 637}, 40, Phaser.Easing.Linear.None)).start();
				});
			});
			
			//========== SHIP LEFT ==========
			game.physics.arcade.overlap(ball, shipLeft, function(ball, shipLeft) {
				ball.body.velocity.y = -590;
				ball.body.velocity.x = -200;
				ball.body.velocity.x *= ballMaxSpeed / Math.sqrt(ball.body.velocity.x * ball.body.velocity.x + ball.body.velocity.y * ball.body.velocity.y);
				ball.body.velocity.y *= ballMaxSpeed / Math.sqrt(ball.body.velocity.x * ball.body.velocity.x + ball.body.velocity.y * ball.body.velocity.y);
				ball.body.velocity.x += ship.deltaX * 10;
				if (!soundsAreMuted && !shipHit.isPlaying) { shipHit.play(); };
				ball.play("ani"+ game.rnd.integerInRange(0, 17));
				ball.body.acceleration.y = 300;
				game.add.tween(ship).to({angle: -10}, 80, Phaser.Easing.Linear.None).chain(game.add.tween(ship).to({angle: 0}, 40, Phaser.Easing.Linear.None)).start();
			});
			
			//========== SHIP LEFT END ==========
			game.physics.arcade.overlap(ball, shipLeftEnd, function(ball, shipLeftEnd) {
				ball.body.velocity.x = (ball.x - shipLeftEnd.world.x)*20;
				ball.body.velocity.y = (ball.y - shipLeftEnd.world.y)*50;
				if (ball.body.velocity.y > -100) ball.body.velocity.y = -100;
				ball.body.velocity.x *= ballMaxSpeed / Math.sqrt(ball.body.velocity.x * ball.body.velocity.x + ball.body.velocity.y * ball.body.velocity.y);
				ball.body.velocity.y *= ballMaxSpeed / Math.sqrt(ball.body.velocity.x * ball.body.velocity.x + ball.body.velocity.y * ball.body.velocity.y);
				if (ball.body.velocity.x > -200) {
					ball.body.velocity.y = -590;
					ball.body.velocity.x = -200;
					ball.body.velocity.x *= ballMaxSpeed / Math.sqrt(ball.body.velocity.x * ball.body.velocity.x + ball.body.velocity.y * ball.body.velocity.y);
					ball.body.velocity.y *= ballMaxSpeed / Math.sqrt(ball.body.velocity.x * ball.body.velocity.x + ball.body.velocity.y * ball.body.velocity.y);
				}
				ball.body.velocity.x += ship.deltaX * 10;
				ball.x += ship.deltaX;
				if (!soundsAreMuted && !shipHit.isPlaying) { shipHit.play(); };
				ball.play("ani"+ game.rnd.integerInRange(0, 17));
				ball.body.acceleration.y = 300;
				game.add.tween(ship).to({angle: -10}, 80, Phaser.Easing.Linear.None).chain(game.add.tween(ship).to({angle: 0}, 40, Phaser.Easing.Linear.None)).start();
			});
			
			//========== SHIP RIGHT ==========
			game.physics.arcade.overlap(ball, shipRight, function(ball, shipRight) {
				ball.body.velocity.y = -590;
				ball.body.velocity.x = 200;
				ball.body.velocity.x *= ballMaxSpeed / Math.sqrt(ball.body.velocity.x * ball.body.velocity.x + ball.body.velocity.y * ball.body.velocity.y);
				ball.body.velocity.y *= ballMaxSpeed / Math.sqrt(ball.body.velocity.x * ball.body.velocity.x + ball.body.velocity.y * ball.body.velocity.y);
				ball.body.velocity.x += ship.deltaX * 10;
				if (!soundsAreMuted && !shipHit.isPlaying) { shipHit.play(); };
				ball.play("ani"+ game.rnd.integerInRange(0, 17));
				ball.body.acceleration.y = 300;
				game.add.tween(ship).to({angle: 10}, 80, Phaser.Easing.Linear.None).chain(game.add.tween(ship).to({angle: 0}, 40, Phaser.Easing.Linear.None)).start();
			});
			
			//========== SHIP RIGHT END ==========
			game.physics.arcade.overlap(ball, shipRightEnd, function(ball, shipRightEnd) {
				ball.body.velocity.x = (ball.x - shipRightEnd.world.x)*20;
				ball.body.velocity.y = (ball.y - shipRightEnd.world.y)*50;
				if (ball.body.velocity.y > -100) ball.body.velocity.y = -100;
				ball.body.velocity.x *= ballMaxSpeed / Math.sqrt(ball.body.velocity.x * ball.body.velocity.x + ball.body.velocity.y * ball.body.velocity.y);
				ball.body.velocity.y *= ballMaxSpeed / Math.sqrt(ball.body.velocity.x * ball.body.velocity.x + ball.body.velocity.y * ball.body.velocity.y);
				if (ball.body.velocity.x < 200) {
					ball.body.velocity.y = -590;
					ball.body.velocity.x = 200;
					ball.body.velocity.x *= ballMaxSpeed / Math.sqrt(ball.body.velocity.x * ball.body.velocity.x + ball.body.velocity.y * ball.body.velocity.y);
					ball.body.velocity.y *= ballMaxSpeed / Math.sqrt(ball.body.velocity.x * ball.body.velocity.x + ball.body.velocity.y * ball.body.velocity.y);
				}
				ball.body.velocity.x += ship.deltaX * 10;
				ball.x += ship.deltaX;
				if (!soundsAreMuted && !shipHit.isPlaying) { shipHit.play(); };
				ball.play("ani"+ game.rnd.integerInRange(0, 17));
				ball.body.acceleration.y = 300;
				game.add.tween(ship).to({angle: 10}, 80, Phaser.Easing.Linear.None).chain(game.add.tween(ship).to({angle: 0}, 40, Phaser.Easing.Linear.None)).start();
			});
			
			
			
			//-------------------------------------------------------------------------
			//                              ORB COLLISION
			//-------------------------------------------------------------------------
			lastXspeed = ball.body.velocity.x;
			lastYspeed = ball.body.velocity.y;
			
			game.physics.arcade.collide(ball, orbs, function(ball, orb) {
				
				ball.play("ani"+ game.rnd.integerInRange(0, 17));
				
				ball.body.velocity.x += (ball.x - orb.x)*10;
				ball.body.velocity.y += (ball.y - orb.y)*10;
				
				speedModifier = -1;
				if (ball.y >= 124 && ball.y <= 484) {
					speedModifier = 1 + ((ball.y - 124) / 360) * .5;
				}
				if (ball.y < 124) speedModifier = 1;
				if (ball.y > 484) speedModifier = 1.5;
				
				ball.body.velocity.x *= (ballMaxSpeed / speedModifier) / Math.sqrt(ball.body.velocity.x * ball.body.velocity.x + ball.body.velocity.y * ball.body.velocity.y);
				ball.body.velocity.y *= (ballMaxSpeed / speedModifier) / Math.sqrt(ball.body.velocity.x * ball.body.velocity.x + ball.body.velocity.y * ball.body.velocity.y);
				
				ball.body.velocity.x += ship.deltaX * 10;
				ball.body.velocity.y += ship.deltaY * 10;
				
				if (orb.key == "asteroid") {
					if (!soundsAreMuted) { asteroidHit.play(); }
					game.add.tween(orb.scale).to({x: 0.85,y: 0.85}, 40, Phaser.Easing.Linear.None).chain(game.add.tween(orb.scale).to({x: 1.05,y: 1.05}, 400, Phaser.Easing.Elastic.Out)).start();
				}
				
				if (orb.key == "fire") {
					orb.body.enable = false;
					if (!soundsAreMuted) { explosion.play(); }
					game.add.tween(orb.scale).to({x: 4,y: 4}, 200, Phaser.Easing.Cubic.Out).start();
					game.add.tween(orb).to({alpha: 0}, 250, Phaser.Easing.Cubic.Out).start().onComplete.add(function() { orb.kill(); });
					
					//========== BLOW UP SURROUNDING ORBS ==========
					for (var n = 0; n < orbs.children.length; n++) {
						if (orbs.children[n].key == "orb" && orbs.children[n].body.enable && orb.world.distance(orbs.children[n].world) < 100) {
							orbs.children[n].body.enable = false;
							if (!soundsAreMuted) {
								switch(game.rnd.integerInRange(1, 3)) {
									case 1: orbHit1.play(); break;
									case 2: orbHit2.play(); break;
									case 3: orbHit3.play(); break;
								}
							};
							
							orbsLeft -= 1;
							progressBar.scale.x += (1 / totalOrbs);
							if (progressBar.scale.x > 1) progressBar.scale.x = 1;
							
							thisOrb = orbs.children[n];
							game.add.tween(orbs.children[n].scale).to({x: 2,y: 2}, 200, Phaser.Easing.Linear.InOut).start();
							game.add.tween(orbs.children[n]).to({alpha: 0}, 200, Phaser.Easing.Linear.InOut).start().onComplete.add(function() { thisOrb.kill(); });
							
							//========== DROP A BONUS ==========
							var k = game.rnd.integerInRange(0, 2);
							for (var j = 0; j < k; j++) {
								for (var i = 0; i < bonuses.children.length; i++) {
									if (bonuses.children[i].status == "ready") {
										bonuses.children[i].start(orbs.children[n].x, orbs.children[n].y, orbs.children[n].frame);
										break;
									}
								}
							}
							
							if (orbsLeft == 1) nextPowerupWait = true;
						}
					}
				}
				
				if (orb.key == "jump") {
					if (!soundsAreMuted && !jumpSound.isPlaying) { jumpSound.play(); };
					
					ball.body.velocity.x = lastXspeed;
					ball.body.velocity.y = lastYspeed;
					
					//========== FIND NEW JUMP GATE ==========
					var jumpGates = [];
					for (var n = 0; n < orbs.children.length; n++) {
						if (orbs.children[n].key == "jump" && !(orbs.children[n].x == orb.x && orbs.children[n].y == orb.y)) jumpGates.push(orbs.children[n]);
					}
					if (jumpGates.length == 0)  jumpGates.push(orb);
					
					//========== DON'T SMACK INTO WALLS ==========
					for (t = 0; t < 10; t++) {
						newGate = jumpGates[game.rnd.integerInRange(0, jumpGates.length - 1)];
						if ((lastXspeed > 0 && newGate.x > 434) || (lastXspeed < 0 && newGate.x < 79) || (lastYspeed < 0 && newGate.y < 149)) {
							newGate = jumpGates[game.rnd.integerInRange(0, jumpGates.length - 1)];
						} else break;
					}
					
					ball.x = newGate.x + (orb.x - ball.x)*1.3;
					ball.y = newGate.y + (orb.y - ball.y)*1.3;
					
					ball.scale.x = 0;
					ball.scale.y = 0;
					game.add.tween(ball.scale).to({x: 1, y: 1}, 200, Phaser.Easing.Linear.None).start();
					
					orb.body.enable = false;
					newGate.body.enable = false;
					
					game.add.tween(orb.scale).to({x: .5,y: .5}, 40, Phaser.Easing.Linear.None).chain(game.add.tween(orb.scale).to({x: 1,y: 1}, 400, Phaser.Easing.Elastic.Out)).start().onComplete.add(function() { orb.body.enable = true; });
					game.add.tween(newGate.scale).to({x: 1.6,y: 1.6}, 40, Phaser.Easing.Linear.None).chain(game.add.tween(newGate.scale).to({x: 1,y: 1}, 400, Phaser.Easing.Elastic.Out)).start().onComplete.add(function() { newGate.body.enable = true; });
				}
				
				if (orb.key == "orb") {
					if (!soundsAreMuted) {
						switch(game.rnd.integerInRange(1, 3)) {
							case 1: orbHit1.play(); break;
							case 2: orbHit2.play(); break;
							case 3: orbHit3.play(); break;
						}
					};
					orb.body.enable = false;
					orbsLeft -= 1;
					progressBar.scale.x += (1 / totalOrbs);
					if (progressBar.scale.x > 1) progressBar.scale.x = 1;
					game.add.tween(orb.scale).to({x: 2,y: 2}, 200, Phaser.Easing.Linear.InOut).start();
					game.add.tween(orb).to({alpha: 0}, 200, Phaser.Easing.Linear.InOut).start().onComplete.add(function() { orb.kill(); });
					
					//========== DROP A BONUS ==========
					var k = game.rnd.integerInRange(0, 2);
					for (var j = 0; j < k; j++) {
						for (var i = 0; i < bonuses.children.length; i++) {
							if (bonuses.children[i].status == "ready") {
								bonuses.children[i].start(orb.x, orb.y, orb.frame);
								break;
							}
						}
					}
					
					if (orbsLeft == 1) nextPowerupWait = true;
				
				}
			});
			
		}
		
		//---------------------------------------------------------------------
		//                              LOST BALL
		//---------------------------------------------------------------------
		if (ballActive && ball.y > 900) {
			if (!soundsAreMuted && ball.visible) { lostBall.play(); };
			ballActive = false;
			progressBar.scale.x -= (1 / totalOrbs);
			if (progressBar.scale.x < 0) progressBar.scale.x = 0;
			newBallWait = true;
		}
		
		//-------------------------------------------------------------------------
		//                              NEW BALL WAIT
		//-------------------------------------------------------------------------
		if (newBallWait && !isPaused) {
			newBallTimer += game.time.elapsed;
			if (newBallTimer > 1000) {
				newBallTimer = 0;
				newBallWait = false;
				newBall();
			}
		}
		
		//-------------------------------------------------------------------------
		//                              NEXT POWERUP WAIT
		//-------------------------------------------------------------------------
		if (nextPowerupWait && !isPaused) {
			nextPowerupTimer += game.time.elapsed;
			if (nextPowerupTimer > 6500) {
				nextPowerupWait = false;
				nextPowerup.status = "falling";
			}
		}
		
		//---------------------------------------------------------------------
		//                              LEVEL DONE
		//---------------------------------------------------------------------
		if (orbsLeft == 0) levelComplete();
		
		//--------------------------------------------------------------------
		//                              SHOW FPS
		//--------------------------------------------------------------------
		if (showFPS) text.setText(game.time.fps);
		
	}
	
}


//===================================================================================
//            _____  _   _  _   _   ____  _____  ___  ___   _   _  ____  
//           |  ___|| | | || \ | | / ___||_   _||_ _|/ _ \ | \ | |/ ___| 
//           | |_   | | | ||  \| || |      | |   | || | | ||  \| |\___ \ 
//           |  _|  | |_| || |\  || |___   | |   | || |_| || |\  | ___) |
//           |_|     \___/ |_| \_| \____|  |_|  |___|\___/ |_| \_||____/ 
//
//===================================================================================

//----------------------------------------------------------------------------------
//                              SHOW MESSAGE FUNCTIONS
//----------------------------------------------------------------------------------
function showMessage(messageToShow) {
	switch(messageToShow) {
		case "get ready":
			messagesFrame = 0;
			messageSound = getReady;
			break;
		case "level done":
			messagesFrame = 1;
			messageSound = levelDone;
			break;
		case "new level":
			messagesFrame = 2;
			messageSound = newLevel;
			break;
		case "paused":
			messagesFrame = 3;
			messageSound = null;
			break;
	}
	messages.y = gameHeight;
	messages.frame = messagesFrame;
	game.add.tween(messages).to({y: gameHeight - 87}, 350, Phaser.Easing.Back.Out, true);
	game.time.events.add(Phaser.Timer.SECOND * 0.25, function() {
		if (!soundsAreMuted && messageSound != null) { messageSound.play(); };
	});
}

function hideMessage() {
	game.add.tween(messages).to({y: gameHeight}, 200, Phaser.Easing.Linear.None, true);
}

//-------------------------------------------------------------------------------------
//                              CHANGE OF STATE FUNCTIONS
//-------------------------------------------------------------------------------------
function gotoMenu() {
	game.time.events.add(Phaser.Timer.SECOND * 0.25, function() {
		if (!menuMusic.isPlaying) menuMusic.play();
		menuMusic.pause();
		playMusic.stop();
		closeDoors("menuState");
	});
}

function gotoLevel() {
	game.time.events.add(Phaser.Timer.SECOND * 0.25, function() {
		if (!menuMusic.isPlaying) menuMusic.play();
		menuMusic.pause();
		playMusic.stop();
		closeDoors("levelState");
	});
}

function replayLevel() {
	game.time.events.add(Phaser.Timer.SECOND * 0.25, function() {
		menuMusic.stop();
		playMusic.stop();
		try {
			parent.cmgGameEvent("replay", playLevel.toString());
		} catch(error) {
			// cmgGameEvent not present
		}
		closeDoors("playState");
	});
}

function nextLevel() {
	game.time.events.add(Phaser.Timer.SECOND * 0.25, function() {
		menuMusic.stop();
		playLevel++;
		if (playLevel == 161) {
			closeDoors("endState");
		} else {
			try {
				parent.cmgGameEvent("start", playLevel.toString());
			} catch(error) {
				// cmgGameEvent not present
			}
			closeDoors("playState");
		}
	});
}

//--------------------------------------------------------------------
//                              NEW BALL
//--------------------------------------------------------------------
function newBall() {
	isNewBall = true;
	ballActive = false;
	showMessage("get ready");
	
	ball.exists = true;
	ball.visible = true;
	ball.body.velocity.x = 0;
	ball.body.velocity.y = 0;
	ball.body.acceleration.x = 0;
	ball.body.acceleration.y = 0;
	ball.play("ani1");
	
	ball.scale.set(3);
	ball.alpha = 0;
	game.add.tween(ball.scale).to({x: 1,y: 1}, 200, Phaser.Easing.Linear.InOut).start();
	game.add.tween(ball).to({alpha: 1}, 200, Phaser.Easing.Linear.InOut).start().onComplete.add(function() {
		game.time.events.add(Phaser.Timer.SECOND * 0.75, function() { 
			if (nextPowerup.status == "done") {
				//========== STOP BALL ==========
				ball.body.velocity.x = 0;
				ball.body.velocity.y = 0;
				ball.body.acceleration.x = 0;
				ball.body.acceleration.y = 0;
				game.physics.arcade.isPaused = false;
				ballActive = false;
				//========== BALL EXPLODE ==========
				game.time.events.add(Phaser.Timer.SECOND * 1.5, function() { 
					game.add.tween(ball.scale).to({x: 4,y: 4}, 250, Phaser.Easing.Linear.InOut).start();
					game.add.tween(ball).to({alpha: 0}, 250, Phaser.Easing.Linear.InOut).start();
				});
			} else {
				ball.body.velocity.setTo(0, -250);
				ball.body.acceleration.y = 500;
				isNewBall = false;
				ballActive = true;
				if (messages.frame == 0) hideMessage();
			}
		});
	});
}

//--------------------------------------------------------------------------
//                              LEVEL COMPLETE
//--------------------------------------------------------------------------
function levelComplete() {
	orbsLeft = -1;
	isPaused = true;
	timeActive = false;
	ballActive = false;
	pauseButton.input.enabled = false;
	
	//========== GET RID OF NEXT POWERUP ==========
	game.add.tween(nextPowerup.scale).to({x: 2,y: 2}, 250, Phaser.Easing.Linear.InOut).start();
	game.add.tween(nextPowerup).to({alpha: 0}, 250, Phaser.Easing.Linear.InOut).start();
	
	//========== KILL REMAINING ORBS AND ASTEROIDS ==========
	for (var i = 0; i < orbs.length; i++) {
		if (orbs.children[i].exists) {
			orbs.children[i].body.enable = false;
			game.add.tween(orbs.children[i].scale).to({x: 2,y: 2}, 200, Phaser.Easing.Linear.InOut).start();
			game.add.tween(orbs.children[i]).to({alpha: 0}, 200, Phaser.Easing.Linear.InOut).start();
		}
	}
	
	//========== STOP BALL ==========
	ball.body.velocity.x = 0;
	ball.body.velocity.y = 0;
	ball.body.acceleration.x = 0;
	ball.body.acceleration.y = 0;
	game.physics.arcade.isPaused = false;
	ballActive = false;
	
	//========== SHOW MESSAGE ==========
	showMessage("level done");
	
	//========== BALL EXPLODE ==========
	game.time.events.add(Phaser.Timer.SECOND * 1.5, function() { 
		game.add.tween(ball.scale).to({x: 4,y: 4}, 250, Phaser.Easing.Linear.InOut).start();
		game.add.tween(ball).to({alpha: 0}, 250, Phaser.Easing.Linear.InOut).start();
	});
	
	playMusic.stop();
	
	game.time.events.add(Phaser.Timer.SECOND * 2.5, function() {
		//========== SHOW WIN DIALOG ==========
		game.add.tween(winDialog.scale).to({x: 1,y: 1}, 500, Phaser.Easing.Elastic.Out, true);
		winDialogActive = true;
		if (!musicIsMuted) { menuMusic.play(); };
		
		//========== HOW MANY STARS TO SHOW ==========
		numberOfStars = 1;
		if (progressBar.scale.x > 0.2875) numberOfStars = 2;
		if (progressBar.scale.x > 0.6075) numberOfStars = 3;
		
		//========== UPDATE LEVELSTATUS ==========
		if (numberOfStars > levelStatus[playLevel - 1]) {
			levelStatus[playLevel - 1] = numberOfStars;
			if (playLevel < 160) {
				if (levelStatus[playLevel] == -1) levelStatus[playLevel] = 0;
			}
			saveData();
		}
		
		//========== SHOW STARS ==========
		game.add.tween(winDialogStar1.scale).to({x: 1, y: 1}, 350, Phaser.Easing.Linear.None, true, 500);
		game.add.tween(winDialogStar1).to({angle: 0}, 350, Phaser.Easing.Linear.None, true, 500);
		game.add.tween(winDialogStar1).to({alpha: 1}, 250, Phaser.Easing.Linear.None, true, 500).onComplete.add(function() {
			if (!soundsAreMuted && winDialogActive) { starSound1.play(); };
		});
		if (numberOfStars > 1) {
			game.add.tween(winDialogStar2.scale).to({x: 1, y: 1}, 350, Phaser.Easing.Linear.None, true, 1000);
			game.add.tween(winDialogStar2).to({angle: 0}, 350, Phaser.Easing.Linear.None, true, 1000);
			game.add.tween(winDialogStar2).to({alpha: 1}, 250, Phaser.Easing.Linear.None, true, 1000).onComplete.add(function() {
				if (!soundsAreMuted && winDialogActive) { starSound2.play(); };
			});
		}
		if (numberOfStars > 2) {
			game.add.tween(winDialogStar3.scale).to({x: 1, y: 1}, 350, Phaser.Easing.Linear.None, true, 1500);
			game.add.tween(winDialogStar3).to({angle: 0}, 350, Phaser.Easing.Linear.None, true, 1500);
			game.add.tween(winDialogStar3).to({alpha: 1}, 250, Phaser.Easing.Linear.None, true, 1500).onComplete.add(function() {
				if (!soundsAreMuted && winDialogActive) { starSound3.play(); };
			});
		}
		
	});
	
}

